﻿Imports ControllerDLL
Imports Un4seen.Bass

Public Class Form1

    'Xbox
    Private LeftStick As New Windows.Vector(0, 0)
    Private RightStick As New Windows.Vector(0, 0)
    Private RightTrigger As Integer
    Private LeftTrigger As Integer
    Private Buttons As New List(Of XBox.Buttons)
    Private WithEvents XBoxController As XBox.Controller

    'SoundPlayer
    Public stream As Integer
    'Public stream2 As IntPtr = Bass.BASS_StreamCreateFile("‪C:\Users\Andre\Videos\Any Video Converter\MP3\menu_start.mp3", 0, 0, BASSFlag.BASS_STREAM_AUTOFREE Or BASSFlag.BASS_STREAM_PRESCAN)

    'Navigiermenü
    Private nav_buttons As New List(Of Button)
    Private CurrentButtonIndex = 0

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'For Each Buttons As Button In Me.Controls
        '    If Buttons.Name.Contains("quick_") = True Then
        '        nav_buttons.Add(Buttons)
        '    End If
        'Next
        'MsgBox(nav_buttons.Count)

        'Konfiguration der Bass.net DLL
        If (Bass.BASS_Init(-1, 44100, BASSInit.BASS_DEVICE_DEFAULT, Me.Handle)) = False Then
            MessageBox.Show("Fehler beim Laden der Library")
        End If
        MsgBox(Bass.BASS_ErrorGetCode)
        stream = Bass.BASS_StreamCreateFile("‪C:\Users\Andre\Videos\Any Video Converter\MP3\menu_select.mp3", 0, 0, BASSFlag.BASS_STREAM_AUTOFREE Or BASSFlag.BASS_STREAM_PRESCAN)
        MsgBox(Bass.BASS_ErrorGetCode)

        ' "Erstellt" das Nivigations Menü
        nav_buttons.Add(quick_exit_btn)
        nav_buttons.Add(quick_hello_btn)
        nav_buttons.Add(quick_hello2_btn)
        nav_buttons.Add(quick_settings_btn)
        nav_buttons.Add(quick_opencmd_btn)
        nav_buttons.Add(Button1)

        ' Konfiguriert den XBOX Controller
        XBoxController = New XBox.Controller(0, Me)
        XBoxController.StartCapturing()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        XBoxController.StopCapturing()
        Bass.BASS_ChannelStop(stream)
        Bass.BASS_StreamFree(stream)
        Bass.FreeMe()
    End Sub

#Region "Analog"

    Private Sub LeftStickSChanged(sender As Object, e As XBox.StickChangedEventArgs) Handles XBoxController.LeftStickChanged
        LeftStick = e.Vector / Short.MaxValue * 100

    End Sub

    Private Sub RightStickChanged(sender As Object, e As XBox.StickChangedEventArgs) Handles XBoxController.RightStickChanged
        RightStick = e.Vector / Short.MaxValue * 100

    End Sub

    Private Sub LeftTriggerChanged(sender As Object, e As XBox.TriggerChangedEventArgs) Handles XBoxController.LeftTriggerChanged
        LeftTrigger = e.Value * 100 \ Byte.MaxValue

    End Sub

    Private Sub RightTriggerChanged(sender As Object, e As XBox.TriggerChangedEventArgs) Handles XBoxController.RightTriggerChanged
        RightTrigger = e.Value * 100 \ Byte.MaxValue
        ProgressBar1.Value = RightTrigger

    End Sub

#End Region

    Private Sub ButtonPressed(sender As Object, e As XBox.ButtonChangedEventArgs) Handles XBoxController.ButtonPressed
        Buttons.Add(e.ChangedButtons)
        ButtonsUpdate()
    End Sub

    Private Sub ButtonReleased(sender As Object, e As XBox.ButtonChangedEventArgs) Handles XBoxController.ButtonReleased
        Buttons.Remove(e.ChangedButtons)
        ButtonsUpdate()
    End Sub

    Private Sub ButtonsUpdate()

        'DPad
        If Buttons.Contains(XBox.Buttons.UP) = True Then

        ElseIf Buttons.Contains(XBox.Buttons.DOWN) = True Then

        ElseIf Buttons.Contains(XBox.Buttons.LEFT) = True Then

            CurrentButtonIndex -= 1
            If CurrentButtonIndex < 0 Then
                CurrentButtonIndex = nav_buttons.Count - 1
            End If
            nav_buttons(CurrentButtonIndex).Select()

            Bass.BASS_ChannelPlay(stream, False)
            MsgBox(Bass.BASS_ErrorGetCode)
        ElseIf Buttons.Contains(XBox.Buttons.RIGHT) = True Then

            CurrentButtonIndex += 1
            If CurrentButtonIndex > nav_buttons.Count - 1 Then
                CurrentButtonIndex = 0
            End If
            nav_buttons(CurrentButtonIndex).Select()

            Bass.BASS_ChannelPlay(stream, False)
        End If

        'ABXY
        If Buttons.Contains(XBox.Buttons.A) = True Then
            nav_buttons(CurrentButtonIndex).PerformClick()

            'Bass.BASS_ChannelPlay(stream2, False)
            MsgBox(Bass.BASS_ErrorGetCode)
        End If

        'Left/Right Buttons

        'Start/Select

    End Sub


    'Buttons
    Private Sub quick_exit_btn_Click(sender As Object, e As EventArgs) Handles quick_exit_btn.Click
        Application.Exit()
    End Sub

    Private Sub quick_hello_btn_Click(sender As Object, e As EventArgs) Handles quick_hello_btn.Click
        MsgBox("Hello!")
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        XBoxController.Vibrate(20, 50)
    End Sub

    Private Sub quick_hello2_btn_Click(sender As Object, e As EventArgs) Handles quick_hello2_btn.Click
        MsgBox("Hello 2!")
    End Sub

    Private Sub quick_settings_btn_Click(sender As Object, e As EventArgs) Handles quick_settings_btn.Click
        settings.Show()
    End Sub
End Class
